// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockPipelineApprovals is an autogenerated mock type for the PipelineApprovals type
type MockPipelineApprovals struct {
	mock.Mock
}

// CreatePipelineApproval provides a mock function with given fields: ctx, req
func (_m *MockPipelineApprovals) CreatePipelineApproval(ctx context.Context, req *models.PipelineApproval) (*models.PipelineApproval, error) {
	ret := _m.Called(ctx, req)

	if len(ret) == 0 {
		panic("no return value specified for CreatePipelineApproval")
	}

	var r0 *models.PipelineApproval
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineApproval) (*models.PipelineApproval, error)); ok {
		return rf(ctx, req)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineApproval) *models.PipelineApproval); ok {
		r0 = rf(ctx, req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineApproval)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PipelineApproval) error); ok {
		r1 = rf(ctx, req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePipelineApproval provides a mock function with given fields: ctx, req
func (_m *MockPipelineApprovals) DeletePipelineApproval(ctx context.Context, req *models.PipelineApproval) error {
	ret := _m.Called(ctx, req)

	if len(ret) == 0 {
		panic("no return value specified for DeletePipelineApproval")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineApproval) error); ok {
		r0 = rf(ctx, req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetPipelineApprovals provides a mock function with given fields: ctx, input
func (_m *MockPipelineApprovals) GetPipelineApprovals(ctx context.Context, input *GetPipelineApprovalsInput) (*PipelineApprovalsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineApprovals")
	}

	var r0 *PipelineApprovalsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelineApprovalsInput) (*PipelineApprovalsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelineApprovalsInput) *PipelineApprovalsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PipelineApprovalsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPipelineApprovalsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockPipelineApprovals creates a new instance of MockPipelineApprovals. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPipelineApprovals(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPipelineApprovals {
	mock := &MockPipelineApprovals{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
